
!MagmaSession class methodsFor: 'initializing' stamp: 'MilanMimica 12/11/2011 16:42'!
cleanUp
	"References to MagmaSessions get stuck in old MethodContext's, preventing garbage-collection.  Run this method and these instances will be cleaned."
	| before after proxies reals |
	self disconnectAndCloseAllConnectedSessions.
	MagmaRepositoryController initialize.
	MCMagmaRepository allSubInstances do:
		[ : each | each cleanUp ].
	MaObjectRepository allInstances do:
		[ : each | each unregisterAsMemoryHog ].
	World cleanseStepList.
	Smalltalk garbageCollect.
	before := self allSubInstances size.
	MaObject hasMaui ifTrue:
		[ (Smalltalk classNamed: #MauiWorld) current
			 clipboard: nil ;
			 rehashPlayers ].
	(Smalltalk classNamed: #TeCellAddress) ifNotNilDo:
		[ : teCellAddress | teCellAddress initializeReusableAddress ].
	proxies := MagmaMutatingProxy allInstances select:
		[ : each | each maRealObjectIsReified ].
	reals := proxies collect:
		[ : each | each realObjectIfMutatingProxy ].
	proxies
		elementsForwardIdentityTo: reals
		copyHash: false.
	Smalltalk garbageCollect.
	self allSubInstances do:
		[ : each | each pointersTo do:
			[ : referencer | referencer class == MethodContext ifTrue: [ referencer receiver: nil ] ] ].
	Smalltalk garbageCollect.
	after := self allSubInstances size.
	SystemNavigation default allObjectsDo:
		[ : e | ((e class inheritsFrom: Object) and: [ e isBehindWriteBarrier ]) ifTrue: [ e primitiveChangeClassTo: e class superclass basicNew ] ].
	^ 'MagmaSession instances (before->after):  ' , (before -> after) printString! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'MilanMimica 12/11/2011 16:41'!
migrateFromTarget: oldSuperclass to: newSuperclass

	| oldClass |

	oldClass := class.
	"Was the immediate WriteBarrier superclass modified (or was it a superclass of that)?"
	(oldClass superclass == newSuperclass)
		ifTrue:
			[ oldClass superclass: oldSuperclass.
			class := self createSubclassOf: newSuperclass.
			class updateInstancesFrom: oldClass ]
		ifFalse:
			[ "Although my class refers to the proper superclass, it must be rebuilt because its format has changed and must now be updated."
			class := self createSubclassOf: oldClass superclass.
			ClassBuilder new mutate: oldClass to: class
"			self
				updateInstancesOf: oldClass
				to:  class" ]! !
